module Network.Salvia.Advanced.ExtendedFileSystem (hExtendedFileSystem) where

import Network.Salvia.Handlers.File (hFile)
import Network.Salvia.Handlers.Directory (hDirectory)
import Network.Salvia.Handlers.FileSystem (hFileTypeDispatcher)
import Network.Salvia.Httpd (Handler)
import Network.Salvia.Advanced.HsColour (hHighlightHaskell, hHsColour)
import Network.Salvia.Advanced.CleverCSS (hFilterCSS, hCleverCSS)

hExtendedFileSystem :: FilePath -> Handler ()
hExtendedFileSystem dir =
  hFileTypeDispatcher dir
    hDirectory
    (hHighlightHaskell hHsColour
      $ hFilterCSS hCleverCSS
      $ hFile)

